/* ----------------------------------------------------------------------------
 *  Serial Communication Lib Test								
 * ----------------------------------------------------------------------------
 *  prog: max.rheiner@zhdk.ch / Zhdk / Interaction Design
 *  date: 11/16/2011
 * ----------------------------------------------------------------------------
 */

#include "serialComLib.h"

// ----------------------------------------------------------------------------
// cmdId constants
#define   CMD_WRITE_DOUT2   1
#define   CMD_READ_DIN3     2
#define   CMD_READ_AD0      3
#define   CMD_RET_READ_DIN3 4
#define   CMD_RET_READ_AD0  5

// ----------------------------------------------------------------------------
// global var

SerialComLib   comLib;

unsigned char  din;

unsigned char  digitalOutPin = 2;
unsigned char  digitalInPin = 3;
unsigned char  analogPin = 0;

void setup()
{
  pinMode(digitalOutPin, OUTPUT); 
  pinMode(digitalInPin, INPUT); 
   
  digitalWrite(digitalOutPin, LOW);
  
  comLib.open(Serial,9600);
} 

unsigned char data[] = {11,22};

void loop()
{
  if(comLib.readPacket() == SerialComLib::Ok)
  { // there is some data on the serial port 
  
    // interprete the command
    switch(comLib.getCmd())
    {
    case CMD_WRITE_DOUT2:
      // set the digital out 2
      digitalWrite(digitalOutPin, comLib.getByte() > 0 ? HIGH : LOW);
      break;
      
    case CMD_READ_DIN3:
      // read in the digtial input 3      
      comLib.beginSend(CMD_RET_READ_DIN3);
        comLib.sendByte(digitalRead(digitalInPin));
      comLib.endSend();
      break;
      
    case CMD_READ_AD0:
      // read in the anolog input 0      
      comLib.beginSend(CMD_RET_READ_AD0);
        comLib.sendInt(analogRead(analogPin));
      comLib.endSend();   
      break;
    default:
      // unknown cmd
      break;
    }
  }
  else
  {  // do something else ???
  
  }
  
}
